package Poputil;

import javax.swing.*;
import javax.swing.table.*;
import java.util.Vector;
import nettoyeur.Progress;

/**
 *
 * <h3>Description : </h3>
 * <p>Contrle les actions d'un 'facteur' :<br>
 * - connection<br>
 * - login<br>
 * - lecture des en-tte des mels<br>
 * - suppression de(s) mel(s)<br>
 * @author yarel
 * @version 1.0
 * </p>
 */

public interface Interfacepoputil {

  /**
   *vrifie les mels sur le compte pop
   * @param serveur String
   * @param port int
   * @return boolean
   */
  boolean connectPop(String serveur, int port);

  /**
   * login
   * @param user String
   * @param password String
   * @return boolean
   */
  boolean loginPop(String user, String password);

  /**
   * affiche la progression dans la progresse barre
   * @param colMsg Msgs
   * @param bar Progress
   */
  void afficheMsgs(Msgs colMsg, Progress bar);

  /**
   * supprime un mel
   * @param index int
   * @return boolean
   */
  boolean killSpam(int index);

  /**
   * renvoi le nombre total de mel
   * @return int
   */
  int getNbrTotalMsg();

  /**
   * deconnection
   * @return boolean
   */
  String quitConnect();

}
