package nettoyeur;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import svgard.Comptepop;
import svgard.Ctrlsvgard;
import java.util.Vector;

public class Principale extends JFrame {
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem1 = new JMenuItem();
  JMenuItem jMenuItem2 = new JMenuItem();
  JMenu jMenu2 = new JMenu();
  JMenu jMenu3 = new JMenu();
  JMenuItem jMenuItem3 = new JMenuItem();
  Ctrlsvgard conf = new Ctrlsvgard();
  Comptepop compteX;
  Thdleon facteur;
  JMenuItem tmp;
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton1 = new JButton();
  JButton cmdSupprime = new JButton();
  JLabel jLabel1 = new JLabel();
  Modelmel modeltablo;
  JTable tablo;
  JScrollPane scroll;
  String[] colums = {
      "N", "DE", "POUR", "SUJET", "DATE"}; //les colonnes des tables
  int nTotalcompte = 0;
  Vector Facteurs;
  JLabel lblDefault;
  ImageIcon imgDefault;

  public Principale() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * init
   * @throws Exception
   */
  private void jbInit() throws Exception {
    jMenu1.setText("Compte");
    jMenuItem1.setText("Nouveau");
    jMenuItem1.addActionListener(new Principale_jMenuItem1_actionAdapter(this));
    jMenuItem2.setText("Quitter");
    jMenuItem2.addActionListener(new Principale_jMenuItem2_actionAdapter(this));
    jMenu2.setText("Relever le courrier");

    jMenu3.setText("Relever tout");
    jMenuItem3.setText("Toutes les boites");
    jMenuItem3.addActionListener(new Principale_jMenuItem3_actionAdapter(this));
    jMenu3.add(jMenuItem3);

    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    this.setLocale(java.util.Locale.getDefault());
    this.setTitle("TuxLeon  e-nettoyeur");
    this.getContentPane().setLayout(borderLayout1);
    jButton1.setText("Fermer l'onglet");
    jButton1.addActionListener(new Principale_jButton1_actionAdapter(this));
    cmdSupprime.setText("Supprimer");
    cmdSupprime.addActionListener(new Principale_cmdSupprime_actionAdapter(this));
    jLabel1.setText("Default");
    jMenuBar1.add(jMenu1);
    jMenuBar1.add(jMenu2);
    jMenuBar1.add(jMenu3);
    jMenu1.add(jMenuItem1);
    jMenu1.add(jMenuItem2);
    jTabbedPane1.setBackground(Color.lightGray);
    jTabbedPane1.setFont(new java.awt.Font("Dialog", 1, 11));
    jTabbedPane1.setForeground(Color.black);
    jTabbedPane1.setBorder(BorderFactory.createEtchedBorder());
    jTabbedPane1.setMinimumSize(new Dimension(147, 59));
    jTabbedPane1.setOpaque(true);
    jTabbedPane1.setPreferredSize(new Dimension(147, 59));

    this.getContentPane().add(jTabbedPane1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(cmdSupprime, null);
    jPanel1.add(jButton1, null);
    setJMenuBar(jMenuBar1);
    setSize(new Dimension(660, 400));

    creerMenuCmpt();
    setDefault();
    Facteurs = new Vector();

  }

  /**
   * l'onglet par defaut
   */
  private void setDefault() {
    imgDefault = new ImageIcon("img/plf2-2.jpg");
    lblDefault = new JLabel(imgDefault);
    jTabbedPane1.add("TuxLon e-nettoyeur", lblDefault);

  }

  /**
   * nouveau compte
   * affiche la fnet
   * de saisie
   */
  private void nouveauCompte() {
    Comptedlg pmain = new Comptedlg(conf);
    //Centrer la fentre
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = pmain.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    pmain.setLocation( (screenSize.width - frameSize.width) / 2,
                      (screenSize.height - frameSize.height) / 2);
    pmain.setModal(true);
    pmain.setVisible(true);
  }

  /**
   * crer le sou-menu relever
   * dans le menu courrier
   */
  private void creerMenuCmpt() {
    nTotalcompte = 0;
    this.conf.chargerComptes(); //charge la collection de compte  partir des fichiers dans le rep 'data'
    nTotalcompte = this.conf.getNbrCompte();
    if (nTotalcompte > 0) {
      for (int i = 0; i < nTotalcompte; i++) {
        this.compteX = this.conf.getCompte(i); //retrouve le compte 'X'  l'indice 0 (le premier) dans la collection
        tmp = new JMenuItem(this.compteX.getStr_user());
        tmp.addActionListener(new Principale_tmp_actionAdapter(this));
        jMenu2.add(tmp);
      }
    }
    /**
     *SI PAS DE COMPTE
     * premier dmarrage
     */
    else {
     /*message d'information si pas de compte dans le rep data*/
      JOptionPane.showMessageDialog(this, "Vous devez crer un premier compte\nMenu Compte->Nouveau "
                                      , "Pas de compte trouv",
                                      JOptionPane.INFORMATION_MESSAGE);

    }

  }

  /**
   *termine le thread leon
   * @param facteurX Thdleon
   * @param lbltable String
   */
  public void KillFacteur(Thdleon facteurX, String lbltable) {
    supprimeTab(lbltable);
    Facteurs.remove(facteurX);
    facteurX = null;
  }

  /*Redfini, ainsi nous pouvons sortir quand la fentre est ferme*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      /*verif si tous les connections sontfermes*/
      if (!Facteurs.isEmpty()) {
        int k = 0;
        for(k = 0; k <= Facteurs.size(); k++){
          deconnection();
        }

     Facteurs.clear();
   }

      System.exit(0);
    }
  }

  /**
   * supprime l'onglet  partir de son libell
   * @param lblTab String
  */
  private void supprimeTab(String lblTab) {
    int j = 0;
    for (j = 0; j < jTabbedPane1.getTabCount(); j++) {
      if (jTabbedPane1.getTitleAt(j).compareTo(lblTab) == 0) {
        jTabbedPane1.remove(j);
        if (jTabbedPane1.getTabCount() == 0) {
          setDefault();
        }
        break;
      }
    }
  }

  /**
   *releve une boite
   * @param e ActonEvent
   */
  void actionPerformed(ActionEvent e) {
    //si multi verif avant
    if (!Facteurs.isEmpty()) {
      Facteurs.removeAllElements();
    }
    tablo = new JTable();
    scroll = new JScrollPane();
    modeltablo = new Modelmel(colums, 0, tablo);
    jTabbedPane1.removeAll();
    String tablibele = new String( ( (JMenuItem) e.getSource()).getText());
    jTabbedPane1.add(tablibele, scroll);
    scroll.getViewport().add(tablo, null);

    compteX = conf.getCompte(tablibele); //retrouve le compte 'X' pour le user 'user'
    facteur = new Thdleon(compteX, modeltablo, this, tablibele);
    Facteurs.add(facteur);
    facteur.start();
  }

  /**
   * releve toutes les boites
   * @param e ActionEvent
   */
  void jMenuItem3_actionPerformed(ActionEvent e) {
    int i = 0;
    if (!Facteurs.isEmpty()) {
      Facteurs.removeAllElements();
    }
    jTabbedPane1.removeAll();
    for (i = 0; i < nTotalcompte; i++) {
      tablo = new JTable();
      scroll = new JScrollPane();
      modeltablo = new Modelmel(colums, 0, tablo);
      compteX = conf.getCompte(i); //retrouve le compte 'X' pour l'indice i
      jTabbedPane1.add(compteX.getStr_user(), scroll);
      scroll.getViewport().add(tablo, null);
      facteur = new Thdleon(compteX, modeltablo, this, compteX.getStr_user());
      Facteurs.add(facteur);
      gerethread(facteur);
    }

  }

  /**
   * gestion des threads
   * @param fx Thdleon
   */
  private void gerethread(Thdleon fx) {
    fx.start();
  }

  /**
   * quitter
   * @param e ActionEvent
   */
  void jMenuItem2_actionPerformed(ActionEvent e) {
    if (!Facteurs.isEmpty()) {
       int k = 0;
       for(k = 0; k <= Facteurs.size(); k++){
         deconnection();
       }

       Facteurs.clear();
     }

    System.exit(0);
  }

  /**
   * nouveau compte
   * @param e ActionEvent
   */
  void jMenuItem1_actionPerformed(ActionEvent e) {
    nouveauCompte();
    jMenu2.removeAll();
    nTotalcompte = 0;
    creerMenuCmpt();
    if (!Facteurs.isEmpty()) {
      Facteurs.clear();
    }

  }

  /**
   * supprime le ou les mels
   * sur le pop3 et
   * dans la tablemel
   * @param e ActionEvent
   */
  void cmdSupprime_actionPerformed(ActionEvent e) {
    int nTab = jTabbedPane1.getSelectedIndex();
    try {
      JTable tableX = ( (Modelmel) ( (Thdleon) Facteurs.get(nTab)).getTab()).
          getTablemodel();
      if (tableX.getSelectedRowCount() == 0) {
        JOptionPane.showMessageDialog(this, "Pas de message slectionn :-("
                                      , "Pas de slection",
                                      JOptionPane.ERROR_MESSAGE);
        return;
      }
      else {
        int[] numligne = tableX.getSelectedRows(); //numero de lignes selectionnes
        int[] nummel = new int[numligne.length];

        for (int i = 0; i < numligne.length; i++) {

          try {
            /*recup la valeur de la cellule "N" par l'intermediaire
                 d'un objet String qui est converti en int afin de permettre
                     de retrouver le n du mel sur le serveur
                 aprs une suppression le n de ligne ne correspond plus !!*/
            Integer tmp = new Integer(new String(tableX.getValueAt(numligne[i],
                0).toString()));
            nummel[i] = tmp.intValue();
          }
          catch (Exception ex) {
            JOptionPane.showMessageDialog(this,
                                          "BUG :-(" + "\n" +
                                          "aparament la valeur" +
                " de la cellule 'un' n'est pas un entier",
                "Suppression impossible ",
                JOptionPane.ERROR_MESSAGE);
          }
        }
        if ( ( (Thdleon) Facteurs.get(nTab)).killSpams(numligne, nummel)) {
          JOptionPane.showMessageDialog(this, "Boite Nettoye ;-) "
                                        , "Suppression Russie ",
                                        JOptionPane.INFORMATION_MESSAGE);
           if(tableX.getRowCount() == 0){  //si plus de mel apres suppression
             deconnection();
           }

        }
        else {
          JOptionPane.showMessageDialog(this,
                                        "Impossible de nettoyer la Boite :-("
                                        , "Suppression impossible ",
                                        JOptionPane.ERROR_MESSAGE);
          return;
        }
      }
    }
    catch (Exception thdex) {
      JOptionPane.showMessageDialog(this,
                                    "Apparament la connection n'existe plus"
                                    , "PAS DE CONNECTION ",
                                    JOptionPane.ERROR_MESSAGE);

    }
  }

  /**
   *deconnection
   * suppression du thread
   * suppression de l'onglet
   */

 private void deconnection() {
    int nTab = jTabbedPane1.getSelectedIndex();
    try {
      if ( ( (Thdleon) Facteurs.get(nTab)) != null) {
        JOptionPane.showMessageDialog(this,
                                      "Dconnection... " +
                                      ( (Thdleon) Facteurs.get(nTab)).
                                      disconnect()
                                      , "Lon nettoyeur :-)",
                                      JOptionPane.INFORMATION_MESSAGE);
        Facteurs.remove(nTab);
        jTabbedPane1.remove(nTab);
      }
      else {
        JOptionPane.showMessageDialog(this, "Pas de connection active"
                                      , "Lon nettoyeur :-)",
                                      JOptionPane.INFORMATION_MESSAGE);

      }
    }
    catch (Exception all) {
      JOptionPane.showMessageDialog(this,
                                    "Apparament la connection n'existe plus"
                                    , "PAS DE CONNECTION",
                                    JOptionPane.ERROR_MESSAGE);
      try {

        jTabbedPane1.remove(nTab);
        if (jTabbedPane1.getComponentCount() == 0) {
          setDefault();
        }

      }
      catch (Exception exepnull) {
        if (jTabbedPane1.getComponentCount() == 0) {
          setDefault();
        }

      }
    }
    if (jTabbedPane1.getComponentCount() == 0) {
      setDefault();
    }

  }

  /*deconnection*/
  void jButton1_actionPerformed(ActionEvent e) {
    deconnection();
  }
}


/*quitter*/
class Principale_jMenuItem2_actionAdapter implements java.awt.event.ActionListener {
  Principale adaptee;

  Principale_jMenuItem2_actionAdapter(Principale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem2_actionPerformed(e);
  }
}

/*relever tous les comptes*/
class Principale_jMenuItem3_actionAdapter implements java.awt.event.ActionListener {
  Principale adaptee;

  Principale_jMenuItem3_actionAdapter(Principale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem3_actionPerformed(e);
  }
}

/*relever un compte*/
class Principale_tmp_actionAdapter implements java.awt.event.ActionListener {
  Principale adaptee;

  Principale_tmp_actionAdapter(Principale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.actionPerformed(e);
  }
}

/*nouveau compte*/
class Principale_jMenuItem1_actionAdapter implements java.awt.event.ActionListener {
  Principale adaptee;

  Principale_jMenuItem1_actionAdapter(Principale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem1_actionPerformed(e);
  }
}
/*deconnection*/
class Principale_jButton1_actionAdapter implements java.awt.event.ActionListener {
  Principale adaptee;

  Principale_jButton1_actionAdapter(Principale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class Principale_cmdSupprime_actionAdapter implements java.awt.event.ActionListener {
  Principale adaptee;

  Principale_cmdSupprime_actionAdapter(Principale adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cmdSupprime_actionPerformed(e);
  }
}
