package nettoyeur;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import svgard.Ctrlsvgard;
/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */

public class Comptedlg extends JDialog{
  GridLayout gridLayout1 = new GridLayout();
  JPanel jPanel1 = new JPanel();
  JTextField txtServeur = new JTextField();
  JLabel lblServeur = new JLabel();
  JPanel jPanel4 = new JPanel();
  JLabel lblPass = new JLabel();
  JPasswordField txtPass = new JPasswordField();
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout3 = new FlowLayout();
  JPanel jPanel6 = new JPanel();
  JButton cmdEnreg = new JButton();
  JButton cmdAnnul = new JButton();
  JTextField txtNomUtil = new JTextField();
  FlowLayout flowLayout2 = new FlowLayout();
  JPanel jPanel5 = new JPanel();
  JLabel lblNomUtil = new JLabel();
  JTextField txtPort = new JTextField();
  JLabel lblPort = new JLabel();
  FlowLayout flowLayout4 = new FlowLayout();
  JPanel jPanel3 = new JPanel();
  String[] str_Params;
  Ctrlsvgard conf;
  boolean benreg;

  /**
   * constructeur
   * avec le controleur des sauvegardes
   * en parametre
   * @param conf Ctrlsvgard
   */
  public Comptedlg(Ctrlsvgard conf){
    this();
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      this.conf = conf;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * constructeur par dfault
   * @param frame Frame
   * @param title String
   * @param modal boolean
   */
  public Comptedlg(Frame frame, String title, boolean modal){
    super(frame,title,modal);
  }

  /**
   *constructeur
   */
  public Comptedlg(){
    this(null,"compte",true);
  }


  private void jbInit() throws Exception {
    this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
    this.setFont(new java.awt.Font("Dialog", 0, 12));
    this.setLocale(java.util.Locale.getDefault());
    this.setResizable(true);
    this.setSize(new Dimension(290, 227));
    this.setTitle("NOUVEAU COMPTE");
    this.getContentPane().setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setHgap(0);
    gridLayout1.setRows(5);
    txtServeur.setAlignmentX((float) 0.5);
    txtServeur.setAlignmentY((float) 0.5);
    txtServeur.setPreferredSize(new Dimension(154, 19));
    txtServeur.setToolTipText("Le nom du serveur pop3");
    txtServeur.setCaretPosition(0);
    txtServeur.setMargin(new Insets(0, 0, 0, 0));
    txtServeur.setHorizontalAlignment(SwingConstants.LEFT);

    lblServeur.setPreferredSize(new Dimension(83, 15));
    lblServeur.setHorizontalAlignment(SwingConstants.LEADING);
    lblServeur.setHorizontalTextPosition(SwingConstants.LEFT);
    lblServeur.setText("Serveur");
    lblPass.setPreferredSize(new Dimension(83, 14));
    lblPass.setText("Mot de passe");

    txtPass.setPreferredSize(new Dimension(154, 19));
    txtPass.setRequestFocusEnabled(true);
    txtPass.setHorizontalAlignment(SwingConstants.LEFT);
    jPanel1.setLayout(flowLayout1);
    jPanel4.setLayout(flowLayout3);
    cmdEnreg.setText("Enregistrer");
    cmdEnreg.addActionListener(new NewCompteDlg_cmdEnreg_actionAdapter(this));
    cmdAnnul.setText("Annuler");
    cmdAnnul.addActionListener(new NewCompteDlg_cmdAnnul_actionAdapter(this));
    txtNomUtil.setPreferredSize(new Dimension(154, 19));
    txtNomUtil.setText("");
    jPanel5.setLayout(flowLayout2);
    lblNomUtil.setPreferredSize(new Dimension(83, 15));
    lblNomUtil.setText("Utilisateur");
    txtPort.setPreferredSize(new Dimension(154, 19));
    txtPort.setMargin(new Insets(0, 0, 0, 0));
    txtPort.setText("110");
    txtPort.setHorizontalAlignment(SwingConstants.LEFT);
    lblPort.setPreferredSize(new Dimension(83, 15));
    lblPort.setText("Port");
    jPanel3.setLayout(flowLayout4);
    jPanel1.setAlignmentX((float) 0.5);
    jPanel1.setBorder(null);
    jPanel6.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setBorder(null);
    jPanel5.setBorder(null);
    jPanel4.setBorder(null);
    jPanel4.setPreferredSize(new Dimension(252, 29));
    flowLayout4.setAlignment(FlowLayout.LEFT);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    flowLayout2.setAlignment(FlowLayout.LEFT);
    flowLayout3.setAlignment(FlowLayout.LEFT);
    this.getContentPane().add(jPanel1,null);
    jPanel1.add(lblServeur, null);
    jPanel1.add(txtServeur, null);
    this.getContentPane().add(jPanel3, null);
    jPanel3.add(lblPort, null);
    jPanel3.add(txtPort, null);
    this.getContentPane().add(jPanel5, null);
    jPanel5.add(lblNomUtil, null);
    jPanel5.add(txtNomUtil, null);
    jPanel6.add(cmdEnreg, null);
    jPanel6.add(cmdAnnul, null);
    this.getContentPane().add(jPanel4, null);
    jPanel4.add(lblPass, null);
    jPanel4.add(txtPass, null);
    this.getContentPane().add(jPanel6, null);
    benreg = false;
    this.requestFocus(true);
  }


  /**
   * enregistre un nouveau compte
   * @param e ActionEvent
   */
  void cmdEnreg_actionPerformed(ActionEvent e) {

    String password = new String(txtPass.getPassword());
    /*controle champ serveur*/
    if(txtServeur.getText().length() <= 0){
      JOptionPane.showMessageDialog(this,"Vous devez saisir le nom du serveur pop3\n ex : pop.free.fr","saisie du serveur manquante",
                                     JOptionPane.ERROR_MESSAGE);
       return;
    }
    /*controle champ nom utilisateur*/
    if(txtNomUtil.getText().length() <= 0){
      JOptionPane.showMessageDialog(this,"Vous devez saisir le nom d'utilisateur de votre compte mail\n que votre F.A.I vous as communiqu\n ex : j.durant@tiscali.fr","saisie de l'utilisateur manquante",
                                     JOptionPane.ERROR_MESSAGE);
       return;
    }
    /*controle champ password*/
    if(password.length() <= 0){
      JOptionPane.showMessageDialog(this,"Vous devez saisir le mot de passe de votre compte mail\n que votre F.A.I vous as communiqu","saisie du mot de passe manquante",
                                     JOptionPane.ERROR_MESSAGE);
       return;
    }



    if(this.conf.nouveauCompte(txtServeur.getText(),txtNomUtil.getText(),
                               txtPort.getText(),password)){

       JOptionPane.showMessageDialog(this,"Enregistrement russi","Enregistrement",
                                     JOptionPane.INFORMATION_MESSAGE);
       this.conf = null;
       this.dispose();
    }
    else{
      JOptionPane.showMessageDialog(this,"Eregistrement impossible","ERREUR",
                                     JOptionPane.ERROR_MESSAGE);
       this.conf = null;
       this.dispose();

    }

 }

 /**
  * annuler
  * @param e ActionEvent
  */
 void cmdAnnul_actionPerformed(ActionEvent e){
   this.dispose();
 }

//Redfini, ainsi nous pouvons sortir quand la fentre est ferme
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }


}

class NewCompteDlg_cmdEnreg_actionAdapter implements java.awt.event.ActionListener {
  Comptedlg adaptee;

  NewCompteDlg_cmdEnreg_actionAdapter(Comptedlg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cmdEnreg_actionPerformed(e);
  }
}

class NewCompteDlg_cmdAnnul_actionAdapter implements java.awt.event.ActionListener{
        Comptedlg adaptee;

        NewCompteDlg_cmdAnnul_actionAdapter(Comptedlg adaptee){
                this.adaptee = adaptee;
        }

        public void actionPerformed(ActionEvent e){
                adaptee.cmdAnnul_actionPerformed(e);
        }

}
