package nettoyeur;

import javax.swing.UIManager;
import java.awt.*;

/**
 *
 * <p>Leon : </p>
 * <h3>Description : </h3>
 * <p>Class comportant le 'main', lance le programme,affiche la fentre de dialogue 'nouveau compte'<br>
 * au premier dmarrage sinon affiche la fentre principale</p>
 *
 * @author yarel
 * @version 1.0
 */
public class Leon {
  boolean packFrame = false;

  /**
   * construit et lance
   * la fenetre principale
   */

  public Leon() {
    Principale frame = new Principale();
    //Valider les cadres ayant des tailles prdfinies
    //Compacter les cadres ayant des infos de taille prfres - ex. depuis leur disposition
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Centrer la fentre
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  /**
   * main
   * @param args String[]
   */
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    new Leon();
  }
}